hdu 2825 Wireless Password(ac自动机&dp)

Wireless Password

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)

Total Submission(s): 4022    Accepted Submission(s): 1196

Problem Description

Liyuan lives in a old apartment. One day, he suddenly found that there was a wireless network in the building. Liyuan did not know the password of the network, but he got some important information from his neighbor. He knew the password
consists only of lowercase letters ‘a‘-‘z‘, and he knew the length of the password. Furthermore, he got a magic word set, and his neighbor told him that the password included at least k words of the magic word set (the k words in the password possibly overlapping).

For instance, say that you know that the password is 3 characters long, and the magic word set includes ‘she‘ and ‘he‘. Then the possible password is only ‘she‘.

Liyuan wants to know whether the information is enough to reduce the number of possible passwords. To answer this, please help him write a program that determines the number of possible passwords.

Input

There will be several data sets. Each data set will begin with a line with three integers n m k. n is the length of the password (1<=n<=25), m is the number of the words in the magic word set(0<=m<=10), and the number k denotes that
the password included at least k words of the magic set. This is followed by m lines, each containing a word of the magic set, each word consists of between 1 and 10 lowercase letters ‘a‘-‘z‘. End of input will be marked by a line with n=0 m=0 k=0, which should
not be processed.

Output

For each test case, please output the number of possible passwords MOD 20090717.

Sample Input

10 2 2
hello
world
4 1 1
icpc
10 0 0
0 0 0

Sample Output

2
1
14195065

Source

2009 Multi-University Training Contest
1 - Host by TJU

Recommend

gaojie   |   We have carefully selected several similar problems for you:  2819 2824 2817 2823 2822

题意:

某人要去破译wifi密码。现在他已经知道密码全部由小写字母组成。且密码的长度n(1<=n<=25)。和m(0<=m<=10)个密码中可能出现的串(magic)。每个串长度不超过10.现在他已经知道密码中这m个串至少出现了k个。可以覆盖出现。现在问你密码可能有多少种。

思路:

由于是专门搜的ac自动机动规的题目。所以就直接往ac自动机动规上想了。这题的难点是确定出现magic中出现了多少个。考虑到m比较小。所以就直接壮压了。最后才取满足条件的状态就行了。

详细见代码:

#include<algorithm>
#include<iostream>
#include<string.h>
#include<sstream>
#include<stdio.h>
#include<math.h>
#include<vector>
#include<string>
#include<queue>
#include<set>
#include<map>
using namespace std;
const int INF=0x3f3f3f3f;
const double eps=1e-8;
const double PI=acos(-1.0);
const int mod=20090717;
const int md=150;
const int ssz=26;
const int maxn=30;
int ch[md][ssz],val[md],f[md],last[md];
int sz,dp[maxn][md][1<<11],one[1<<11],bi[11];
int idx(char c) { return c-'a'; }
void init()
{
    sz=1;
    val[0]=0;
    memset(ch[0],0,sizeof ch[0]);
}
void Insert(char *s,int v)
{
    int u=0,n=strlen(s);
    for(int i=0; i<n; i++)
    {
        int c=idx(s[i]);
        if(!ch[u][c])
        {
            memset(ch[sz],0,sizeof ch[sz]);
            val[sz]=0;
            ch[u][c]=sz++;
        }
        u=ch[u][c];
    }
    val[u]=v;
}
void getf()
{
    queue<int> q;
    int u,v,c,r;
    f[0]=0;
    for(c=0;c<ssz;c++)
    {
        u=ch[0][c];
        if(u)
        {
            f[u]=0;
            q.push(u);
            last[u]=0;
        }
    }
    while(!q.empty())
    {
        r=q.front();
        q.pop();
        val[r]|=val[f[r]];
        for(c=0;c<ssz;c++)
        {
            u=ch[r][c];
            if(!u)
            {
                ch[r][c]=ch[f[r]][c];
                continue;
            }
            q.push(u);
            v=f[r];
            while(v&&!ch[v][c])
                v=f[v];
            f[u]=ch[v][c];
        }
    }
}
void solve(int n,int k,int ms)
{
    int i,j,s,c,v,ns,ans;
    getf();
    for(i=0;i<=n;i++)
        for(j=0;j<sz;j++)
            for(s=0;s<ms;s++)
                dp[i][j][s]=0;
    dp[0][0][0]=1;
    for(i=0;i<n;i++)
        for(j=0;j<sz;j++)
            for(s=0;s<ms;s++)
            {
                if(!dp[i][j][s])
                    continue;
                for(c=0;c<ssz;c++)
                {
                    v=ch[j][c],ns=s|val[v];
                    dp[i+1][v][ns]=(dp[i+1][v][ns]+dp[i][j][s])%mod;
                }
            }
    ans=0;
    for(s=0;s<ms;s++)
    {
        if(one[s]<k)
            continue;
        for(i=0;i<sz;i++)
            ans=(ans+dp[n][i][s])%mod;
    }
    printf("%d\n",ans);
}
int getone(int x)
{
    int c=0;
    while(x)
    {
        c+=x&1;
        x>>=1;
    }
    return c;
}
int main()
{
    int i,n,m,k;
    char magic[20];

    bi[0]=1;
    for(i=1;i<11;i++)
        bi[i]=bi[i-1]<<1;
    for(i=0;i<bi[10];i++)
        one[i]=getone(i);
    while(scanf("%d%d%d",&n,&m,&k),n||m||k)
    {
        init();
        for(i=0;i<m;i++)
        {
            scanf("%s",magic);
            Insert(magic,bi[i]);
        }
        solve(n,k,bi[m]);
    }
    return 0;
}

hdu 2825 Wireless Password(ac自动机&dp),布布扣,bubuko.com

时间: 2024-08-08 01:27:39

hdu 2825 Wireless Password(ac自动机&dp)的相关文章

HDU 2825 Wireless Password AC自动机+dp

训练赛第二场的I题,上完体育课回来就把这题过了,今天训练赛rank1了,还把大大队虐了,而且我还过了这道题 (虽然我也就过了这道题...),第一次在比赛中手写AC自动机还带dp的,心情大好. 给一个字符串集合,求包含该集合超过K个字符的,长度为L的字符串的个数. 显然是在AC自动机上跑dp,设dp[u][L][k]表示当前在结点u,还要走L步,当前状态为k的个数.一开始第三维表示的是包含k个字符串,但是题目要求不含重复的,那就只能状压了.转移为dp[u][L][k]+=dp[v][L-1][nk

hdu 2825 Wireless Password(AC自动机+状压DP)

题目链接:hdu 2825 Wireless Password 题目大意:N,M,K,M个字符串作为关键码集合,现在要求长度为N,包含K个以上的关键码的字符串有多少个. 解题思路:AC自动机+dp,滚动数组,因为关键码个数不会超过10个,所以我们用二进制数表示匹配的状态.dp[i][j][k] 表示到第i个位置,j节点,匹配k个字符串. #include <cstdio> #include <cstring> #include <queue> #include <

HDU 2825 Wireless Password (AC自动机,DP)

http://acm.hdu.edu.cn/showproblem.php?pid=2825 Wireless Password Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others) Total Submission(s): 4560    Accepted Submission(s): 1381 Problem Description Liyuan lives in a old a

hdu 2825 Wireless Password(ac自己主动机&amp;amp;dp)

Wireless Password Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others) Total Submission(s): 4022    Accepted Submission(s): 1196 Problem Description Liyuan lives in a old apartment. One day, he suddenly found that there

HDU 2825 Wireless Password (AC自动机 + 状态压缩DP)

题目链接:Wireless Password 解析:给 m 个单词构成的集合,统计所有长度为 n 的串中,包含至少 k 个单词的方案数. AC自动机 + 状态压缩DP. DP[i][j][k]:长度为i的字符串匹配到状态j且包含k个magic word的可能字符串个数. AC代码: #include <algorithm> #include <iostream> #include <cstdio> #include <queue> #include <

HDU 2825 Wireless Password(自动机+DP)

Problem Description Liyuan lives in a old apartment. One day, he suddenly found that there was a wireless network in the building. Liyuan did not know the password of the network, but he got some important information from his neighbor. He knew the p

HDU 2457 DNA repair AC自动机 + dp

http://acm.hdu.edu.cn/showproblem.php?pid=2457 首先把病毒串保存一下,然后对于每一个trie上的节点,跑一发AC自动机,建立一个trie图. 建立的时候,对应做一些修改. 比如,现在建立成了这个样子. 如果he是一个病毒串,那么应该相对应的,把she那个he的位置,标志上,它也是病毒串,也就是不能转移到这一个状态. 这个可以在buildfail的时候对应修改. dp, 设dp[i][j],表示处理到字符串的第i个,走到了AC自动机的第j个节点,变成了

[AC自动机+状压dp] hdu 2825 Wireless Password

题意: 给n,m,k ,再给出m个单词 问长度为n的字符串,至少在m个单词中含有k个的组成方案有多少种. 思路: 由于m最大是10,所以可以采取状压的思想 首先建立trie图,在每个单词的结束节点标记一个mark=(1<<id),id为单词的编号 然后需要注意的,对于每个节点,应该顺着fail指针遍历一遍, 把所有的mark取一个并集. 因为就是如果单词出现包含的话,比如 she和he 我拿了she,其实等于两个都拿了. dp[i][j][k]  i步在节点j状态k的方案数 然后就是一个四重循

HDU 2296 Ring (AC自动机 + DP)

题目链接:Ring 解析:m个有价值的串,字符串s在字符串str中的价值 = s在str中出现的次数 × s的价值.问价值最大的长度为n的串是什么. 本题需要输出字典序最小的 在DP的时候开一个数组记录结果即可. AC代码: #include <algorithm> #include <iostream> #include <cstdio> #include <queue> #include <cstring> using namespace s